#include <semaphore.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>

#include "err.h"

#define SEMAPHORE_NAME "sem.txt"


int main(int argc, char** argv) {
  sem_t* semaphore;
  int err;
  int val;
  int operation;
  
  if (argc != 2) {
    fprintf(stderr, "expected single argument: +1 (post), -1 (wait) or 0 (unlink)\n");
    return 1;
  }
  operation = atoi(argv[1]);
  if ((operation < -1) || (operation > 1)) {
    fprintf(stderr, "expected single argument: +1 (post), -1 (wait) or 0 (unlink)\n");
    return 1;
  }

  if (operation == 0) { // unlink
    if ((err = sem_unlink(SEMAPHORE_NAME)) != 0)
      syserr("sem_unlink");    
  } else { // post or wait
    semaphore = sem_open(SEMAPHORE_NAME, O_CREAT, 0666, 0);
    if (semaphore == SEM_FAILED)
      syserr("sem_open");

    if ((err = sem_getvalue(semaphore, &val)) != 0)
      syserr("sem_getvalue");
    printf("semaphore value: %d\n", val);
    
    if (operation == 1) {
      printf("posting\n");
      if ((err = sem_post(semaphore)) != 0 )
	syserr("sem_post");
      printf("posting finished\n");
    } else {
      printf("waiting\n");
      if ((err = sem_wait(semaphore)) != 0 )
	syserr("sem_wait");
      printf("waiting finished\n");
    }

    if ((err = sem_getvalue(semaphore, &val)) != 0)

      syserr("sem_getvalue");
    printf("semaphore value: %d\n", val);

    if ((err = sem_close(semaphore)) != 0 )
      syserr("sem_close");
  }
  return 0;
}
